datablock ParticleData(RifleTrailRingParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = 0;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 600;
	lifetimeVarianceMS   = 35;
	textureName          = "base/data/particles/thinRing";
	spinSpeed		= 0;
	spinRandomMin		= 0;
	spinRandomMax		= 0;
	colors[0]     = "1 1 1 0.9";
	colors[1]     = "1 1 1 0.8";
	sizes[0]      = 0.2;
	sizes[1]      = 0.3;

	useInvAlpha = false;
};
datablock ParticleEmitterData(RifleTrailRingEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "RifleTrailRingParticle";

   useEmitterColors = true;
   uiName = "Rifle Trail";
};

AddDamageType("Rifle",   '<bitmap:add-ons/Weapon_RifleFix/CI_Rifle> %1',    '%2 <bitmap:add-ons/Weapon_RifleFix/CI_Rifle> %1',0.2,1);
datablock ProjectileData(RifleProjectile : gunProjectile)
{
   directDamage        = 60;
   directDamageType    = $DamageType::Rifle;
   radiusDamageType    = $DamageType::Rifle;
   particleEmitter     = "RifleTrailRingEmitter";

   muzzleVelocity      = 140;

   uiName = "Rifle Bullet";
};

//////////
// item //
//////////
datablock ItemData(RifleItem : gunItem)
{
	shapeFile = "./Rifle.dts";
	uiName = "Rifle";
	iconName = "./icon_Rifle";
	image = RifleImage;
	colorShiftColor = "0.5 0.5 0.5 1.000";
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(RifleImage)
{
   // Basic Item properties
   shapeFile = "./Rifle.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = RifleItem;
   ammo = " ";
   projectile = RifleProjectile;
   projectileType = Projectile;

	casing = gunShellDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;
   minShotTime = 1400;

   doColorShift = true;
   colorShiftColor = RifleItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.11;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;
	stateSequence[1]	= "Ready";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Smoke";
	stateTimeoutValue[2]            = 0.11;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;
	stateEmitter[2]					= gunFlashEmitter;
	stateEmitterTime[2]				= 0.05;
	stateEmitterNode[2]				= "muzzleNode";
	stateSound[2]					= gunShot1Sound;
	stateEjectShell[2]       = true;

	stateName[3] = "Smoke";
	stateEmitter[3]					= gunSmokeEmitter;
	stateEmitterTime[3]				= 0.05;
	stateEmitterNode[3]				= "muzzleNode";
	stateTimeoutValue[3]            = 0.01;
	stateTransitionOnTimeout[3]     = "Reload";

	stateName[4]= "Reload";
	stateSequence[4]                = "Reload";
	stateTimeoutValue[4]            = 1.3;
	stateTransitionOnTimeout[4]     = "Ready";
	stateWaitForTimeout[4]		= true;


};

function RifleImage::onFire(%this,%obj,%slot)
{
	if(%obj.getDamagePercent() < 1.0)
		%obj.playThread(2, plant);
	Parent::onFire(%this,%obj,%slot);	
}
